#include "map.h"
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_FILE_SIZE 1024 * 16

int load_elements(hashmap *m, char *table, int use_inv) {
  FILE *fptr;

  fptr = fopen(table, "r");

  if (fptr == NULL)
    return 0;

  char *str;

  int did_something = 0;

  while (1) {
    str = calloc(MAX_FILE_SIZE, sizeof(char));
    if (!fgets(str, MAX_FILE_SIZE, fptr))
      break;

    did_something = 1;

    if (use_inv) {
      hashmap_set(m, str, strlen(str) - 2, (uintptr_t)1);
      continue;
    }

    char *combo = strstr(str, ";");
    combo[0] = '\0';
    combo++;

    hashmap_set(m, combo, strlen(combo) - 1, (uintptr_t)str);
  }


  printf("%i\n",did_something);

  if (!did_something) {
    free(str);
  }

  return did_something;

  // todo: properly free this
}